-- HivemindLetters - Released during BFA

local HivemindLetters = ...

HivemindLetters = LibStub("AceAddon-3.0"):NewAddon("HivemindLetters", "AceConsole-3.0", "AceEvent-3.0")

local optionsFrame = ""

HivemindLetters.fQuestNum = ""
HivemindLetters.fQuestName = ""
HivemindLetters.fQuestId = ""
HivemindLetters.fQuestFound = ""
HivemindLetters.fDetailsText = ""
HivemindLetters.fNotEquiped = "|cffffff00|Hitem:27944::::::::::::|h[Talisman of True Treasure Tracking]|cFFFF0000 Not Equiped!|h|r"
HivemindLetters.fEquiped = "|cffffff00|Hitem:27944::::::::::::|h[Talisman of True Treasure Tracking]|cFF00FF00 Is Equiped!|h|r"
HivemindLetters.fGroup = "|cff0083e8<Hivemind Helper>|cffffff3aJoin the group click this link :|cff82c5ff|HclubTicket:yZpwM0KsOdv|h[Hivemind Helper]|h|r"

HivemindLetters.fLetters = {
	[0] = "Letter 1",
	[1] = "Letter 2",
	[2] = "Letter 3",
	[3] = "Letter 4",
	[4] = "Letter 5",
	[5] = "Letter 6",
	[6] = "Letter 7",
	[7] = "Gift",
}

HivemindLetters.fLocations = {
	[0] = "/way Shattrath City:Outland 65.6 69.3 Griftah",
	[1] = "/way Highmountain:Broken Isles 57.4 27.9 Second Letter",
	[2] = "/way Deadwind Pass 47.0, 69.9 Karazhan Entrance",
	[3] = "/way Thousand Needles 45.7 24.0 Razorfen Downs Entrance",
	[4] = "/way Mount Hyjal 44.3 47.3 Entrance to room with Fifth Letter",
	[5] = "/way Icecrown 70.8 73.3 Sixth Letter",
	[6] = "/way Townlong Steppes 37.7 63.0 Seventh Letter",
	[7] = "/way Borean Tundra 27.6 27.1 Gift of Ms. Graham",
}

HivemindLetters.fReport = {
	[0] = "Shattrath City:Outland Griftah Waypoint added!",
	[1] = "Highmountain:Broken Isles Waypoint added!",
	[2] = "Deadwind Pass Karazhan Waypoint added!",
	[3] = "Thousand Needles Razorfen Downs Waypoint added!",
	[4] = "Mount Hyjal Waypoint added!",
	[5] = "Icecrown Waypoint added!",
	[6] = "Townlong Steppes Waypoint added!",
	[7] = "Borean Tundra Waypoint added!",
}

local MyMinimap = {
        type = "launcher",
        text = "HivemindLetters",
        icon = "Interface\\Addons\\HivemindLetters\\Icons\\Hivemind",
        OnClick = function( f, button )
                      LibStub("AceConfigDialog-3.0"):Open("HivemindLetters")
                    GameTooltip:Hide()
                  end,
        OnTooltipShow = function( mt )
                          mt:AddDoubleLine( "Hivemind Helper", Minimap.text )
                          mt:AddLine( "|cFFFFFFFFClick to open the the Hivemind Helper interface.|r" )
                        end,
} 

HivemindLetters:RegisterChatCommand("mychat", "ChatCommand")

-- Show the GUI if no input is supplied, otherwise handle the chat input.
function HivemindLetters:ChatCommand(input)
  -- Assuming "MyOptions" is the appName of a valid options table
  if not input or input:trim() == "" then
    LibStub("AceConfigDialog-3.0"):Open("options")
  else
    LibStub("AceConfigCmd-3.0").HandleCommand(HivemindLetters, "mychat", "options", input)
  end
end

function RunSlashCmd(cmd)
	local slash, rest = cmd:match("^(%S+)%s*(.-)$")
	ChatFrame_ImportAllListsToHash()
	local handler = hash_SlashCmdList[slash:upper()]
	if handler then
		handler(rest)
	end
end

function HivemindLetters:SetQuestId(newValue, num, QName)
    self.fQuestId = newValue
	self.fQuestNum = num
	self.fQuestName = QName
	
    isCompleted = IsQuestFlaggedCompleted(self.fQuestId)
    if isCompleted and fQuestId ~= 50181 then 
        self.fQuestFound = self.fQuestFound .. "|cFF00FF00 You have completed letter " .. self.fQuestNum .. " : " .. self.fQuestName .. "|r\n"
    elseif isCompleted == false and fQuestId ~= 50181 then
        self.fQuestFound = self.fQuestFound .. "|cFFFF0000 You have not done letter " .. self.fQuestNum .. " : " .. self.fQuestName .. "|r\n"
	elseif isCompleted and fQuestId == 50181 then
		self.fQuestFound = self.fQuestFound .. "|cFF00FF00 You have completed " .. self.fQuestNum .. " : " .. self.fQuestName .. "|r\n"
	elseif isCompleted == false and fQuestId == 50181 then
		self.fQuestFound = self.fQuestFound .. "|cFFFF0000 You have not done " .. self.fQuestNum .. " : " .. self.fQuestName .. "|r\n"
    end
	LibStub("AceConfigRegistry-3.0"):NotifyChange("HivemindLetters")
end

function HivemindLetters:OnFill()
	self.fQuestFound = ""
	HivemindLetters:SetQuestId(40397,1,"Shattrath")
	HivemindLetters:SetQuestId(40314,2,"Highmountain")
	HivemindLetters:SetQuestId(40404,3,"Karazhan")
	HivemindLetters:SetQuestId(40252,4,"Razorfen Downs")
	HivemindLetters:SetQuestId(40293,5,"Shrine of Aviana, Mount Hyjal")
	HivemindLetters:SetQuestId(40288,6,"Ironwall Dam, between Crystalsong and Icecrown")
	HivemindLetters:SetQuestId(50187,7,"Niuzao Temple, Townlong Steppes")
	HivemindLetters:SetQuestId(50181,"Gift", "Ms. Graham - Coldarra, Borean Tundra")
end

function HivemindLetters:LetterNum()
	if self.DB.profile.minimap.seltest == 0 then
		HivemindLetters:ShowLetterOne()
	elseif self.DB.profile.minimap.seltest == 1 then
		HivemindLetters:ShowLetterTwo()
	elseif self.DB.profile.minimap.seltest == 2 then
		HivemindLetters:ShowLetterTree()
	elseif self.DB.profile.minimap.seltest == 3 then
		HivemindLetters:ShowLetterFour()
	elseif self.DB.profile.minimap.seltest == 4 then
		HivemindLetters:ShowLetterFive()
	elseif self.DB.profile.minimap.seltest == 5 then
		HivemindLetters:ShowLetterSix()
	elseif self.DB.profile.minimap.seltest == 6 then
		HivemindLetters:ShowLetterSeven()
	elseif self.DB.profile.minimap.seltest == 7 then
		HivemindLetters:ShowGift()
	end
end

function HivemindLetters:GetSelVal(info)
	return self.DB.profile.minimap.seltest
end

function HivemindLetters:ResetWay()
	RunSlashCmd("/way reset all")
end

function HivemindLetters:EquipTalisman()
	EquipItemByName(27944)
end

function HivemindLetters:IsTalismanEquip(info)
	if IsEquippedItem(27944) then
		return self.fEquiped
	else
		return self.fNotEquiped
	end
end

function HivemindLetters:SetSelVal(info , newValue)
	self.DB.profile.minimap.seltest = newValue
	self:Print(HivemindLetters.fReport[self.DB.profile.minimap.seltest])
	RunSlashCmd(self.fLocations[self.DB.profile.minimap.seltest])
	HivemindLetters:OnFill()
	LibStub("LibDBIcon-1.0"):Refresh( "HivemindLetters", self.DB.profile.minimap )
end

function HivemindLetters:GetOptions()
  local options = {
    name = "HivemindLetters",
    handler = HivemindLetters,
    type = 'group',
    args = {
	    intro = {
		    order = 1,
			  type = "description",
			  name = "HivemindLetters tell you if you have completed a letter quest and details where to get them.(Blue Monocle)",
		  },
      qf = {
        order = 2,
        type = "input",
        name = "Letters",
        desc = "A list of the quests status",
        usage = "List of quests and completion status.",
        get = 'GetQuestFound',
        set = 'SetQuestFound',
        width = "full",
        multiline = 8,
		disabled = true,
      },
	  et = {
		order = 3,
        type = "execute",
        name = "Equip",
		image = "Interface\\Icons\\inv_jewelry_necklace_12",
		imageCoords = {0.1,0.9,0.1,0.9},
		imageWidth = 30,
		imageHeight = 30,
		width = 0.3,
		func = 'EquipTalisman'
      },
	  ne = {
        order = 4,
        type = "input",
        name = "Talisman Equiped?",
        get = 'IsTalismanEquip',
        width = 2,
        multiline = false,
		disabled = true,
      },
	  cl = {
        order = 5,
        type = "select",
        name = "TomTom Coordinate",
        desc = "Click to set TomTom Coordinate.",
		values = self.fLetters,
		get = "GetSelVal",
        set = "SetSelVal",
      },
	  rw = {
		order = 6,
        type = "execute",
        name = "Reset Waypoints",
		desc = "Remove all waypoints from the map.",
		func = 'ResetWay',
      },
	  sd = {
		order = 7,
        type = "execute",
        name = "Show Details",
		desc = "Show the details where the selected letter is.",
		func = 'LetterNum'
      },
	  rf = {
		order = 8,
        type = "execute",
        name = "Refresh",
		desc = "Refresh Quest Status.",
		func = 'OnFill',
      },
	  hp = {
		order = 9,
        type = "execute",
        name = "Green Monocle",
		desc = "Open the Jumping Puzzle & Skyreach Console Sequences interface for the Green Monocle.",
		func = 'ShowHivemindPlates',
      },
	  ht = {
		order = 10,
        type = "execute",
        name = "Red Monocle",
		desc = "Open the tokens hunt interface for the Red Monocle in Vashj'ir.",
		func = 'ShowHivemindTokens',
      },
	  jg = {
		order = 11,
        type = "execute",
        name = "Join Group",
		desc = "Join the community for any questions, suggestions or feedback. This button generate a link.",
		func = 'ShowGroupLink',
      },
      mm = {
		order = 12,
        type = "toggle",
        name = "Hide Minimap Icon",
        desc = "If checked, the minimap icon will be hidden.",
        get = 'GetOption',
        set = 'SetOption',
      },
    },
  }
  return options
end
  
function HivemindLetters:SetOption( info, input)
    self.DB.profile.minimap.hide = input
    LibStub("LibDBIcon-1.0"):Refresh( "HivemindLetters", self.DB.profile.minimap )
end
  
function HivemindLetters:GetOption( info)
    return self.DB.profile.minimap.hide            
end

function HivemindLetters:ShowGroupLink()
	DEFAULT_CHAT_FRAME:AddMessage(self.fGroup)
end

function HivemindLetters:ShowHivemindPlates()
	RunSlashCmd("/hp")
end

function HivemindLetters:ShowHivemindTokens()
	RunSlashCmd("/ht")
end

function HivemindLetters:ClearVars(info)
    fQuestName = ""
    fQuestId = ""
    fQuestFound = ""
	fQuestNum = ""
end

function HivemindLetters:GetDefaults()
  local defaults = {
    profile = {
      minimap = { 
        hide = false,
      }
    },
  }  
  return defaults
end

-- Not using 
function HivemindLetters:TotalRefresh()
    LibStub("LibDBIcon-1.0"):Refresh( "HivemindLetters", self.DB.profile.minimap )    
end

function HivemindLetters:OnInitialize()
    -- Called when the addon is loaded
    self.DB = LibStub( "AceDB-3.0" ):New( "HivemindLettersDB", self:GetDefaults() )

    self.Options = HivemindLetters:GetOptions()
	self:RegisterEvent("BAG_UPDATE")
	self:RegisterEvent("QUEST_FINISHED")
	self:RegisterEvent("QUEST_LOG_UPDATE")
	self:RegisterEvent("QUEST_ITEM_UPDATE")
    LibStub("AceConfig-3.0"):RegisterOptionsTable("HivemindLetters", self.Options, {"hl"})
    LibStub("AceConfigDialog-3.0"):SetDefaultSize("HivemindLetters", 540, 440)
    optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("HivemindLetters", "HivemindLetters")
    self:RegisterChatCommand("hl", function() LibStub("AceConfigDialog-3.0"):Open("HivemindLetters") end)
    
    LibStub("LibDataBroker-1.1"):NewDataObject("HivemindLetters", MyMinimap);
    LibStub("LibDBIcon-1.0"):Register("HivemindLetters", MyMinimap, self.DB);
end

function HivemindLetters:ChatCommand(input)
   if not input or input:trim() == "" then
       InterfaceOptionsFrame_OpenToCategory(optionsFrame)
   else     
        LibStub("AceConfigCmd-3.0"):HandleCommand("hl", input)
   end
end

function HivemindLetters:GetQuestFound(info)
    return self.fQuestFound
end

function HivemindLetters:SetQuestFound(info, newValue)
    self.fQuestFound = newValue
end

function HivemindLetters:GetQuestId()
    return self.fQuestId
end

function HivemindLetters:OnEnable()
    -- Called when the addon is enabled
    if self.DB.profile.minimap.hide == true then
      self:Print("HivemindLetters enabled.  Minimap Icon is hidden.")
    else
      self:Print("HivemindLetters enabled.  Minimap Icon is shown.")
    end
    LibStub("LibDBIcon-1.0"):Refresh( "HivemindLetters", self.DB.profile.minimap )
end

function HivemindLetters:OnDisable()
    -- Called when the addon is disabled
    self:Print("HivemindLetters disabled.")
end

function HivemindLetters:BAG_UPDATE()
    if IsEquippedItem(27944) then
		HivemindLetters:OnFill()
	else
		if GetItemCount(27944) ~= 0 then
			HivemindLetters:OnFill()
		end
	end
end

function HivemindLetters:QUEST_FINISHED()
    HivemindLetters:OnFill()
end

function HivemindLetters:QUEST_LOG_UPDATE()
    HivemindLetters:OnFill()
end

function HivemindLetters:QUEST_ITEM_UPDATE()
    HivemindLetters:OnFill()
end

StaticPopupDialogs["SHATTRATH_LOCATION"] = {
  text = "Shattrath City is located in Outland. You need to get a |cffffff00|Hitem:27944::::::::::::|h[Talisman of True Treasure Tracking]|h|r from Griftah. Very important, since you must wear it to see and interact with many objects in this guide. Once you get the Talisman, equip it and then click on the Letter from Ms. Graham right side of the table behind Griftah. Click Refresh button to see if the quest is completed if not updated automatically.",
  button1 = "Close",
  OnAccept = function()
      --Do something
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

function HivemindLetters:ShowLetterOne()
	StaticPopup_Show("SHATTRATH_LOCATION")
end

StaticPopupDialogs["LETTERTWO_LOCATION"] = {
  text = "Highmountain is located in Legion, the second letter is located in one of the tents at the Prepfoot Compound on a wooden box where the TomTom location is. To interact with this letter, you MUST have completed letter1.",
  button1 = "Close",
  OnAccept = function()
      --Do something
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

function HivemindLetters:ShowLetterTwo()
	StaticPopup_Show("LETTERTWO_LOCATION")
end

StaticPopupDialogs["LETTERTREE_LOCATION"] = {
  text = "Karazhan is located in Deadwind Pass southern Eastern Kingdoms, the third letter is located in Medivh's Chambers, located after the Chess Event, in the staircase leading to Prince Malchezaar. The letter is on the chair Medivh used to write his scrolls and spells, literally the seat of the guardian. To interact with this letter, you MUST have letter1 and 2.",
  button1 = "Close",
  OnAccept = function()
      --Do something
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

function HivemindLetters:ShowLetterTree()
	StaticPopup_Show("LETTERTREE_LOCATION")
end

StaticPopupDialogs["LETTERFOUR_LOCATION"] = {
  text = "Razorfen Downs is located in Thousand Needles in Kalimdor. The letter is located on a hay box behind the last boss, Death Speaker Blackthorn. To interact with this letter, you MUST have interacted with the previous letters",
  button1 = "Close",
  OnAccept = function()
      --Do something
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

function HivemindLetters:ShowLetterFour()
	StaticPopup_Show("LETTERFOUR_LOCATION")
end

StaticPopupDialogs["LETTERFIVE_LOCATION"] = {
  text = "Mount Hyjal is located in Kalimdor. The letter is at the Shrine of Aviana on a table at the highest floor of the tree that serves as her shrine. To interact with this letter, you MUST have interacted with the previous letters.",
  button1 = "Close",
  OnAccept = function()
      --Do something
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

function HivemindLetters:ShowLetterFive()
	StaticPopup_Show("LETTERFIVE_LOCATION")
end

StaticPopupDialogs["LETTERSIX_LOCATION"] = {
  text = "Icecrown is located in Northrend. The letter is on a spike of the structure where the TomTom location is. To interact with this letter, you MUST have interacted with the previous letters.",
  button1 = "Close",
  OnAccept = function()
      --Do something
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

function HivemindLetters:ShowLetterSix()
	StaticPopup_Show("LETTERSIX_LOCATION")
end

StaticPopupDialogs["LETTERSEVEN_LOCATION"] = {
  text = "Townlong Steppes is located in Pandaria. The letter is located at Niuzao Temple near a bell on the back part of the temple where the TomTom location is. To interact with this letter, you MUST have interacted with the previous letters.",
  button1 = "Close",
  OnAccept = function()
      --Do something
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

function HivemindLetters:ShowLetterSeven()
	StaticPopup_Show("LETTERSEVEN_LOCATION")
end

StaticPopupDialogs["GIFT_LOCATION"] = {
  text = "Ms. Graham give us the last gift, located atop the highest Nexus ring in Coldarra, Borean Tundra in Northrend. The Blue Crystal Monocle is finally ours! To interact with the gift, you MUST have Completed all letters quests.",
  button1 = "Close",
  OnAccept = function()
      --Do something
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

function HivemindLetters:ShowGift()
	StaticPopup_Show("GIFT_LOCATION")
end

C_Timer.After(3, function() DEFAULT_CHAT_FRAME:AddMessage("|cff0083e8<HivemindLetters loaded!>|cffffff3aType /hl to open addon!|r") end)
