-- HivemindPlates - Released during BFA

local HivemindPlates = ...

HivemindPlates = LibStub("AceAddon-3.0"):NewAddon("HivemindPlates", "AceConsole-3.0", "AceEvent-3.0")

local optionsFrame = ""
local fNextPlates = "|cFF00FF00 1 Player 1 = Forward - Forward|r\n"
					.."|cFF00FF00 2 Player 2 = Forward - Left - Forward|r\n"
					.."|cFF00FF00 3 Player 1 = Forward|r\n"
					.."|cFF00FF00 4 Player 3 = Forward - Forward - Right -Right|r\n"
					.."|cFF00FF00 5 Player 4 = Forward - Left|r\n"
					.."|cFF00FF00 6 Player 5 = Forward|r\n"
					.."|cFF00FF00 7 Player 2 = Left|r\n"
					.."|cFF00FF00 8 Player 4 = Forward|r\n"
					.."|cFF00FF00 9 Player 2 = Left|r\n"
					.."|cFF00FF00 10 Player 4 = Left - Forward|r\n"
					.."|cFF00FF00 11 Player 2 = Forward - Left|r\n"
					.."|cFF00FF00 12 Player 3 = Backward|r\n"
					.."|cFF00FF00 13 Player 5 = Forward - Right - Right - Right|r\n"
					.."|cFF00FF00 14 Player 3 = Forward|r\n"
					.."|cFF00FF00 15 Player 5 = Forward|r\n"
					.."|cFF00FF00 16 Player 1 = Right - Forward|r\n"
					.."|cFF00FF00 17 Player 3 = Backward - Forward - Right|r\n"
					.."|cFF00FF00 18 Player 1 = Forward - Left|r\n"
					.."|cFF00FF00 19 Player 4 = Forward|r\n"
					.."|cFF00FF00 20 Player 2 = Backward - Forward|r\n"
					.."|cFF00FF00 21 Player 5 = Forward|r\n"
					.."|cFF00FF00 22 Player 2 = Backward - Forward|r\n"
					.."|cFF00FF00 23 Player 5 = Right|r\n"
					.."|cFF00FF00 24 Player 3 = Forward|r\n"
					.."|cFF00FF00 25 Player 1 = Forward - Right|r\n"
					.."|cFF00FF00 26 Player 2 = Forward - Right|r\n"
					.."|cFF00FF00 27 Player 4 = Forward|r\n"
					.."|cFF00FF00 28 Player 1 = Right - Forward|r\n"
					.."|cFF00FF00 29 Player 3 = Left|r\n"
					.."|cFF00FF00 30 Player 4 = Forward|r\n"
					.."|cFF00FF00 31 Player 3 = Forward - Forward|r\n"
					.."|cFF00FF00 32 Player 5 = Forward|r\n"
					.."|cFF00FF00 33 Player 1 = Left|r\n"
					.."|cFF00FF00 34 Player 4 = Right|r\n"
					.."|cFF00FF00 35 Player 5 = Left|r\n"
					.."|cFF00FF00 36 Player 2 = Forward|r\n"
					.."|cFF00FF00 37 Player 4 = Forward|r\n"
					.."|cFF00FF00 38 Player 5 = Forward - Forward|r\n"
					.."|cFF00FF00 39 Player 1 = Forward|r\n"
					.."|cFF00FF00 40 Player 3 = Left|r\n"
					.."|cFF00FF00 41 Player 5 = Right - Forward|r\n"
					.."|cFF00FF00 42 Player 4 = Forward|r\n"
					.."|cFF00FF00 43 Player 1 = Right|r\n"
					.."|cFF00FF00 44 Player 5 = Left|r\n"
					.."|cFF00FF00 45 Player 1 = Forward|r\n"
					.."|cFF00FF00 46 Player 2 = Forward|r\n"
					.."|cFF00FF00 47 Player 3 = Jump off! (leave vehicle, only this person!).|r\n"
					.."|cFF00FF00 48 Player 3 = Jump on the left-most disk|r\n"
					.."|cFF00FF00 49 Player 3 = Forward|r\n"
					.."|cFF00FF00 50 Player 2 = Forward|r\n"
					.."|cFF00FF00 51 Player 3 = Forward - Forward - Forward|r\n"
					.."|cFF00FF00 52 Player 2 = Backward|r\n"
					.."|cFF00FF00 53 Player 4 = Right|r\n"
					.."|cFF00FF00 54 Player 5 = Forward|r\n"
					.."|cFF00FF00 55 Player 2 = Forward - Right - Forward|r\n"
					.."|cFF00FF00 56 Player 3 = Forward - Forward - Forward - Forward|r\n"
					.."|cFF00FF00 57 All Player = Leave vehicule (Complete)|r\n"
					
local fNextButton = "|cFF00FF00 1 Right ->|r\n"
					.."|cFF00FF00 2 Up ->|r\n"
					.."|cFF00FF00 3 Down ->|r\n"
					.."|cFF00FF00 4 Up ->|r\n"
					.."|cFF00FF00 5 Right ->|r\n"
					.."|cFF00FF00 6 Right ->|r\n"
					.."|cFF00FF00 7 Up ->|r\n"
					.."|cFF00FF00 8 Left ->|r\n"
					.."|cFF00FF00 9 Down ->|r\n"
					.."|cFF00FF00 10 Up ->|r\n"
					.."|cFF00FF00 11 Left ->|r\n"
					.."|cFF00FF00 12 Down ->|r\n"
					.."|cFF00FF00 Done! ->|r\n"
					
local MyMinimap = {
        type = "launcher",
        text = "HivemindPlates",
        icon = "Interface\\Addons\\HivemindPlates\\Icons\\Hivemind",
        OnClick = function( f, button )
                    --if button == "RightButton" then 
                      LibStub("AceConfigDialog-3.0"):Open("HivemindPlates")
                    --end
                    GameTooltip:Hide()
                  end,
        OnTooltipShow = function( mt )
                          mt:AddDoubleLine( "HivemindPlates", Minimap.text )
                          mt:AddLine( "|cFFFFFFFFClick to open the the HivemindPlates interface.|r" )
                        end,
} 

function HivemindPlates:GetOptions()
  local options = {
    name = "HivemindPlates",
    handler = HivemindPlates,
    type = 'group',
    args = {
	    intro = {
		    order = 1,
			  type = "description",
			  name = "Jumping Puzzle & Skyreach Console Sequences",
		  },
      qf = {
        order = 2,
        type = "input",
        name = "Sequences",
        desc = "A list of the Sequences.",
        usage = "Follow the sequences to complete these puzzle.",
        get = "GetNextPlates",
        width = "full",
        multiline = 15,
      },
	  cl = {
		order = 3,
        type = "toggle",
        name = "Skyreach Console Sequences",
        desc = "Fill the text block with the console sequence.",
        get = 'GetSequences',
        set = 'SetSequences',
      },
	  mm = {
		order = 4,
        type = "toggle",
        name = "Hide Minimap Icon",
        desc = "If checked, the minimap icon will be hidden.",
        get = 'GetOption',
        set = 'SetOption',
      },
	  sr = {
        order = 5,
        type = "execute",
        name = "Where is Skyreach?",
        desc = "Set the waypoint to Skyreach entrance.",
        func = "ShowPup",
      },
    },
  }
  return options
end
  
function HivemindPlates:SetOption( info, input)
    self.DB.profile.minimap.hide = input
    LibStub("LibDBIcon-1.0"):Refresh( "HivemindPlates", self.DB.profile.minimap )
end
  
function HivemindPlates:GetOption( info)
    return self.DB.profile.minimap.hide            
end

function HivemindPlates:SetSequences( info, input)
    self.DB.profile.minimap.seq = input
    LibStub("LibDBIcon-1.0"):Refresh( "HivemindPlates", self.DB.profile.minimap )
end
  
function HivemindPlates:GetSequences( info)
    return self.DB.profile.minimap.seq            
end

function HivemindPlates:ClearVars(info)
    fNextPlates = ""
end

function RunSlashCmd(cmd)
	local slash, rest = cmd:match("^(%S+)%s*(.-)$")
	ChatFrame_ImportAllListsToHash()
	local handler = hash_SlashCmdList[slash:upper()]
	if handler then
		handler(rest)
	end
end

StaticPopupDialogs["SKYREACH_LOCATION"] = {
  text = "Skyreach is located in Draenor:Spires of Arak, You can get to Draenor using the Dark Portal and located in Blasted Lands in southern Eastern Kingdoms. Do you want to set a TomTom waypoint for Skyreach on the map?",
  button1 = "Yes",
  button2 = "No",
  OnAccept = function()
      HivemindPlates:SetWay()
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  preferredIndex = 3,
}

function HivemindPlates:ShowPup()
	StaticPopup_Show("SKYREACH_LOCATION")
end

function HivemindPlates:SetWay()
    RunSlashCmd("/way Spires of Arak 35.55, 33.47 Skyreach Entrance")
	print("Waypoint Added! Check you map at Draenor.")
end

function HivemindPlates:GetDefaults()
  local defaults = {
    profile = {
      minimap = { 
        hide = true,
      }
    },
  }  
  return defaults
end

-- Not using 
function HivemindPlates:TotalRefresh()
    LibStub("LibDBIcon-1.0"):Refresh( "HivemindPlates", self.DB.profile.minimap )    
end

function HivemindPlates:OnInitialize()
    -- Called when the addon is loaded
    self.DB = LibStub( "AceDB-3.0" ):New( "HivemindPlatesDB", self:GetDefaults() )

    self.Options = HivemindPlates:GetOptions()
	
    LibStub("AceConfig-3.0"):RegisterOptionsTable("HivemindPlates", self.Options, {"hp"})
    LibStub("AceConfigDialog-3.0"):SetDefaultSize("HivemindPlates", 420, 410)
    optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("HivemindPlates", "HivemindPlates")
    self:RegisterChatCommand("hp", function() LibStub("AceConfigDialog-3.0"):Open("HivemindPlates") end)
    
    LibStub("LibDataBroker-1.1"):NewDataObject("HivemindPlates", MyMinimap);
    LibStub("LibDBIcon-1.0"):Register("HivemindPlates", MyMinimap, self.DB);
end

function HivemindPlates:ChatCommand(input)
   if not input or input:trim() == "" then
       InterfaceOptionsFrame_OpenToCategory(optionsFrame)
   else     
        LibStub("AceConfigCmd-3.0"):HandleCommand("hp", input)
   end
end

function HivemindPlates:OnEnable()
    -- Called when the addon is enabled
    if self.DB.profile.minimap.hide == true then
      self:Print("HivemindPlates enabled.  Minimap Icon is hidden.")
    else
      self:Print("HivemindPlates enabled.  Minimap Icon is shown.")
    end
    LibStub("LibDBIcon-1.0"):Refresh( "HivemindPlates", self.DB.profile.minimap )
end

function HivemindPlates:OnDisable()
    -- Called when the addon is disabled
    self:Print("HivemindPlates disabled.")
end

function HivemindPlates:GetNextPlates(info)
	if self.DB.profile.minimap.seq then
		return fNextButton
	else
		return fNextPlates
	end
end

function HivemindPlates:SetNextPlates(info, newValue)
    fNextPlates = ""
end

C_Timer.After(3, function() DEFAULT_CHAT_FRAME:AddMessage("|cff0083e8<HivemindPlates loaded!>|cffffff3aType /hp to open addon!|r") end)